﻿function GetBehaviorSettings()
{
	return {
		"name":			"Bounded Drag & Drop",			// as appears in 'add behavior' dialog, can be changed as long as "id" stays the same
		"id":			"CV_BoundedDragnDrop",			// this is used to identify this behavior and is saved to the project; never change it
		"version":		"1.0",					// (float in x.y format) Behavior version - C2 shows compatibility warnings based on this
		"description":	"An advanced version of Drag and drop. Drags & Drops objects either by mouse or touch with bounds.",
		"author":		"Chadori_RebornXD & Scirra",
		"help url":		"http://www.google.com/",
		"category":		"Chadori_RebornXD",				// Prefer to re-use existing categories, but you can set anything here
		"flags":		0						// uncomment lines to enable flags...
						| bf_onlyone			// can only be added once to an object, e.g. solid
	};
};

////////////////////////////////////////
// Parameter types:
// AddNumberParam(label, description [, initial_string = "0"])			// a number
// AddStringParam(label, description [, initial_string = "\"\""])		// a string
// AddAnyTypeParam(label, description [, initial_string = "0"])			// accepts either a number or string
// AddCmpParam(label, description)										// combo with equal, not equal, less, etc.
// AddComboParamOption(text)											// (repeat before "AddComboParam" to add combo items)
// AddComboParam(label, description [, initial_selection = 0])			// a dropdown list parameter
// AddObjectParam(label, description)									// a button to click and pick an object type
// AddLayerParam(label, description)									// accepts either a layer number or name (string)
// AddLayoutParam(label, description)									// a dropdown list with all project layouts
// AddKeybParam(label, description)										// a button to click and press a key (returns a VK)
// AddAudioFileParam(label, description)								// a dropdown list with all imported project audio files

////////////////////////////////////////
// Conditions

// AddCondition(id,					// any positive integer to uniquely identify this condition
//				flags,				// (see docs) cf_none, cf_trigger, cf_fake_trigger, cf_static, cf_not_invertible,
//									// cf_deprecated, cf_incompatible_with_triggers, cf_looping
//				list_name,			// appears in event wizard list
//				category,			// category in event wizard list
//				display_str,		// as appears in event sheet - use {0}, {1} for parameters and also <b></b>, <i></i>, and {my} for the current behavior icon & name
//				description,		// appears in event wizard dialog when selected
//				script_name);		// corresponding runtime function name
							
AddCondition(0, cf_none, "Is dragging", "", "{my} is dragging", "True if the object is currently being dragged.", "IsDragging");
AddCondition(1, cf_trigger, "On drag start", "", "On {my} drag start", "Triggered when the object begins to be dragged.", "OnDragStart");
AddCondition(2, cf_trigger, "On drop", "", "On {my} drop", "Triggered when the object is dropped (the drag stops).", "OnDrop");
AddCondition(3, cf_none, "Is enabled", "", "{my} is enabled", "True if the behavior is enabled.", "IsEnabled");

//Chadori_RebornXD start

AddCondition(4, cf_trigger, "On any bound exceeded", "Bound", "On {my} any bound exceeded", "Triggered when the drag is beyond any kind of boundings.", "OnAnyBoundExceeded");

AddCondition(5, cf_trigger, "On radius exceeded", "Radius", "On {my} any radius exceeded", "Triggered when the drag is beyond any radius boundings.", "OnRadiusExceeded");

AddCondition(6, cf_trigger, "On position exceeded", "Position", "On {my} any position exceeded", "Triggered when the drag is beyond any position boundings.", "OnPositionExceeded");

AddCondition(7, cf_none, "Is radius exceeded", "Radius", "On {my} X radius exceeded", "Triggered when the drag is beyond X radius boundings.", "IsRadiusExceeded");

AddCondition(8, cf_none, "Is position exceeded", "Position", "On {my} X position exceeded", "Triggered when the drag is beyond X position boundings.", "IsPositionExceeded");



//Chadori_RebornXD end

////////////////////////////////////////
// Actions

// AddAction(id,				// any positive integer to uniquely identify this action
//			 flags,				// (see docs) af_none, af_deprecated
//			 list_name,			// appears in event wizard list
//			 category,			// category in event wizard list
//			 display_str,		// as appears in event sheet - use {0}, {1} for parameters and also <b></b>, <i></i>
//			 description,		// appears in event wizard dialog when selected
//			 script_name);		// corresponding runtime function name

AddComboParamOption("Disabled");
AddComboParamOption("Enabled");
AddComboParam("State", "Choose whether to enable or disable the behavior.");
AddAction(0, af_none, "Set enabled", "", "Set {my} {0}", "Enable or disable the drag and drop behavior.", "SetEnabled");

AddAction(1, af_none, "Drop", "", "Drop {my}", "If currently being dragged, force the object to be dropped.", "Drop");

//Chadori_RebornXD start

AddComboParamOption("Off");
AddComboParamOption("Both");	
AddComboParamOption("Radius");	
AddComboParamOption("Position");							
AddComboParam("BoundTo", "To which point the object is bounded." , "Off");		
AddAction(2, af_none, "Set BoundTo", "Bound", "Bound {my} to {0}", "Which to is the object bounded.", "SetBoundTo");

AddComboParamOption("Origin");
AddComboParamOption("Edge");								
AddComboParam("BoundBy", "From which point the object is bounded." , "Origin");		
AddAction(3, af_none, "Set BoundBy", "Bound", "Bound {my} by {0}", "Set the point object is bounded.", "SetBoundBy");

AddComboParamOption("Halt");
AddComboParamOption("Clamp");								
AddComboParam("Bound Method", "'Halt' bounding method is rough while `Clamp` is smooth." , "Halt");		
AddAction(4, af_none, "Set Bound Method", "Bound", "Bound {my} by {0}", "Choose whether the object is halted or clamped when bounded.", "SetBoundMethod");

AddNumberParam("XRadius", "The radius in the X-axis it can move from its bound point. 0 is 'off'.", "0");
AddNumberParam("YRadius", "The radius in Y which it can move from its bound point. 0 is 'off'.", "0");
AddAction(5, af_none, "Set Bound XYRadius", "Radius", "{my} : Set Bound XYRadius to ({0},{1})", "The radius in the X & Y axis it can move from its bound point. Both 0 is 'off'.", "SetXYRadius");

AddNumberParam("XRadius", "The radius in which it can move from its bound point. 0 is 'off'.", "0");
AddAction(6, af_none, "Set Bound XRadius", "Radius", "{my} : Set Bound XRadius to {0}", "The radius in the X-axis it can move from its bound point.", "SetXRadius");

AddNumberParam("YRadius", "The radius in which it can move from its bound point. 0 is 'off'.", "0");
AddAction(7, af_none, "Set Bound YRadius", "Radius", "{my} : Set Bound YRadius to {0}", "The radius in the Y-axis it can move from its bound point.", "SetYRadius");

AddNumberParam("Minimum BoundX", "The Minimum X-position it can only move from its bound point.", "0");
AddNumberParam("Maximum BoundX", "The Maximum X-position it can only move from its bound point.", "0");
AddNumberParam("Minimum BoundY", "The Minimum Y-position it can only move from its bound point.", "0");
AddNumberParam("Maximum BoundY", "The Maximum Y-position it can only move from its bound point.", "0");
AddAction(8, af_none, "Set Bound Position", "Position", "{my} : Set Bound Position from ({0},{2}) to ({1},{3})", "The X location it can only move from its bound point.", "SetBoundPosition");

AddNumberParam("Minimum BoundX", "The Minimum X-position it can only move from its bound point.", "0");
AddNumberParam("Maximum BoundX", "The Maximum X-position it can only move from its bound point.", "0");
AddAction(9, af_none, "Set Bound X Position", "Position", "{my} : Set Bound X from {0} to {1}", "The X location it can only move from its bound point.", "SetBoundX");

AddNumberParam("Minimum BoundY", "The Minimum Y-position it can only move from its bound point.", "0");
AddNumberParam("Maximum BoundY", "The Maximum Y-position it can only move from its bound point.", "0");
AddAction(10, af_none, "Set Bound Y Position", "Position", "{my} : Set Bound Y from {0} to {1}", "The Y location it can only move from its bound point.", "SetBoundY");

AddNumberParam("OriginX", "Overwrite the origin point X of creation. Default : Instance creation X.", "0");
AddNumberParam("OriginY", "Overwrite the origin point X of creation. Default : Instance creation Y.", "0");
AddAction(11, af_none, "Overwrite Origin Position", "Bound", "{my} : Overwrite Origin Position to ({0},{1})", "Overwrite the origin point (X,Y) of creation. Becareful when using this.", "OverwriteOrigin");

//Chadori_RebornXD end

////////////////////////////////////////
// Expressions

// AddExpression(id,			// any positive integer to uniquely identify this expression
//				 flags,			// (see docs) ef_none, ef_deprecated, ef_return_number, ef_return_string,
//								// ef_return_any, ef_variadic_parameters (one return flag must be specified)
//				 list_name,		// currently ignored, but set as if appeared in event wizard
//				 category,		// category in expressions panel
//				 exp_name,		// the expression name after the dot, e.g. "foo" for "myobject.foo" - also the runtime function name
//				 description);	// description in expressions panel

//Chadori_RebornXD start

AddExpression(0, ef_return_string, "Leet expression", "Bound", "BoundTo", "Return to which point the object is bounded.");

AddExpression(1, ef_return_string, "Leet expression", "Bound", "BoundBy", "Return from which point the object is bounded.");

AddExpression(2, ef_return_string, "Leet expression", "Bound", "BoundMethod", "Return whether the object bound method is 'halt' or 'clamped'");

AddExpression(3, ef_return_number, "Leet expression", "Bound Radius", "xBoundRadius", "Return the X Bound radius length.");

AddExpression(4, ef_return_number, "Leet expression", "Bound Radius", "yBoundRadius", "Return the Y Bound radius length.");

AddExpression(5, ef_return_number, "Leet expression", "Bound Position", "xMinBoundPos", "Return the Minimum X Bound Position.");

AddExpression(6, ef_return_number, "Leet expression", "Bound Position", "xMaxBoundPos", "Return the Maximum X Bound Position.");

AddExpression(7, ef_return_number, "Leet expression", "Bound Position", "yMinBoundPos", "Return the Minimum Y Bound Position.");

AddExpression(8, ef_return_number, "Leet expression", "Bound Position", "yMaxBoundPos", "Return the Maximum Y Bound Position.");

AddExpression(9, ef_return_number, "Leet expression", "Bound Origin", "xOrigin", "Return the Origin X of creation.");

AddExpression(10, ef_return_number, "Leet expression", "Bound Origin", "yOrigin", "Return the Origin Y of creation.");

//Chadori_RebornXD end

////////////////////////////////////////
ACESDone();

////////////////////////////////////////
// Array of property grid properties for this plugin
// new cr.Property(ept_integer,		name,	initial_value,	description)		// an integer value
// new cr.Property(ept_float,		name,	initial_value,	description)		// a float value
// new cr.Property(ept_text,		name,	initial_value,	description)		// a string
// new cr.Property(ept_combo,		name,	"Item 1",		description, "Item 1|Item 2|Item 3")	// a dropdown list (initial_value is string of initially selected item)

var property_list = [
	new cr.Property(ept_combo,		"Axes",	"Both",		"Which ways the object can be dragged.", "Both|Horizontal only|Vertical only"),
	new cr.Property(ept_combo, "Initial state", "Enabled", "Whether to initially have the behavior enabled or disabled.", "Disabled|Enabled"),

	new cr.Property(ept_combo,		"Bound To",	"Radius",		"Which to is the object bounded.", "Off|Both|Radius|Position"),

	new cr.Property(ept_combo,		"Bound By",	"Origin",		"From which point the object is bounded.", "Origin|Edge"),

	new cr.Property(ept_combo,		"Bound Method",	"Clamp",		"Choose whether the object is halted or clamped when bounded.", "Halt|Clamp"),

	new cr.Property(ept_integer, 	"Bound XRadius",		100,		"The radius in the X-axis it can move from its bound point."),
	new cr.Property(ept_integer, 	"Bound YRadius",		100,		"The radius in the Y-axis it can move from its bound point."),
	new cr.Property(ept_integer, 	"Bound Min X",		0,		"The Minimum X location it can only move from its bound point."),
	new cr.Property(ept_integer,    "Bound Max X",      0,      "The Maximum X location it can only move from its bound point."),
	new cr.Property(ept_integer, 	"Bound Min Y",		0,		"The Minimum Y location it can only move from its bound point."),
	new cr.Property(ept_integer, 	"Bound Max Y",		0,		"The Maximum Y location it can only move from its bound point.")
	];
	
// Called by IDE when a new behavior type is to be created
function CreateIDEBehaviorType()
{
	return new IDEBehaviorType();
}

// Class representing a behavior type in the IDE
function IDEBehaviorType()
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");
}

// Called by IDE when a new behavior instance of this type is to be created
IDEBehaviorType.prototype.CreateInstance = function(instance)
{
	return new IDEInstance(instance, this);
}

// Class representing an individual instance of the behavior in the IDE
function IDEInstance(instance, type)
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");
	
	// Save the constructor parameters
	this.instance = instance;
	this.type = type;
	
	// Set the default property values from the property table
	this.properties = {};
	
	for (var i = 0; i < property_list.length; i++)
		this.properties[property_list[i].name] = property_list[i].initial_value;
		
	// any other properties here, e.g...
	// this.myValue = 0;
}

// Called by the IDE after all initialization on this instance has been completed
IDEInstance.prototype.OnCreate = function()
{
}

// Called by the IDE after a property has been changed
IDEInstance.prototype.OnPropertyChanged = function(property_name)
{
}
